Index: /experiments/frams/capture-the-flag/data/scripts/Flag.neuro
===================================================================
--- /experiments/frams/capture-the-flag/data/scripts/Flag.neuro	(revision 479)
+++ /experiments/frams/capture-the-flag/data/scripts/Flag.neuro	(revision 480)
@@ -10,5 +10,5 @@
 function init(){
 //	Neuro.signals.add("Flag");
-//	Neuro.signals[0].flavor = Fields.team;
+//	Neuro.signals[0].flavor = NeuroProperties.team;
 //	Neuro.signals[0].power = 0;
 }
@@ -16,5 +16,5 @@
 function go()
 {
-	var output = Neuro.signals.receiveFilter("Flag", 2000, Fields.team, 0.5);
+	var output = Neuro.signals.receiveFilter("Flag", 2000, NeuroProperties.team, 0.5);
 	Neuro.state = output;
 	
@@ -22,5 +22,5 @@
 ~
 
-prop:
+property:
 id:team
 name:Team number
Index: /experiments/frams/capture-the-flag/data/scripts/FlagDef.neuro
===================================================================
--- /experiments/frams/capture-the-flag/data/scripts/FlagDef.neuro	(revision 479)
+++ /experiments/frams/capture-the-flag/data/scripts/FlagDef.neuro	(revision 480)
@@ -10,5 +10,5 @@
 function init(){
 //	Neuro.signals.add("Flag");
-//	Neuro.signals[0].flavor = Fields.team;
+//	Neuro.signals[0].flavor = NeuroProperties.team;
 //	Neuro.signals[0].power = 0;
 }
@@ -17,22 +17,22 @@
 {
 	//Check own flag
-	if (Neuro.signals.receiveFilter("Flag", 2000, Fields.my + 100, 0.5) > 0)
-		Neuro.state = Neuro.signals.receiveFilter("Flag", 2000, Fields.my + 100, 0.5);
+	if (Neuro.signals.receiveFilter("Flag", 2000, NeuroProperties.my + 100, 0.5) > 0)
+		Neuro.state = Neuro.signals.receiveFilter("Flag", 2000, NeuroProperties.my + 100, 0.5);
 	//Check opponent flag
 	//If flag is taken -> go to own flag
-	else if (Neuro.signals.receiveFilter("Flag", 2000, Fields.opp + 100, 0.5) > 0)	
-		Neuro.state = Neuro.signals.receiveFilter("Flag", 2000, Fields.my, 0.5);
+	else if (Neuro.signals.receiveFilter("Flag", 2000, NeuroProperties.opp + 100, 0.5) > 0)	
+		Neuro.state = Neuro.signals.receiveFilter("Flag", 2000, NeuroProperties.my, 0.5);
 	//else -> go to opponent flag
 	else
-		Neuro.state = Neuro.signals.receiveFilter("Flag", 2000, Fields.opp, 0.5);
+		Neuro.state = Neuro.signals.receiveFilter("Flag", 2000, NeuroProperties.opp, 0.5);
 }
 ~
 
-prop:
+property:
 id:opp
 name:Opponent team number
 type:d
 
-prop:
+property:
 id:my
 name:My team number
Index: /experiments/frams/capture-the-flag/data/scripts/capture-the-flag.expdef
===================================================================
--- /experiments/frams/capture-the-flag/data/scripts/capture-the-flag.expdef	(revision 479)
+++ /experiments/frams/capture-the-flag/data/scripts/capture-the-flag.expdef	(revision 480)
@@ -28,11 +28,11 @@
    	World.wrldbnd = 2; //Teleport
    	
-   	ExpParams.memberssno = 4;
-   	ExpParams.teamsno = 2;
-   	ExpParams.mindistance = 60;
+   	ExpProperties.memberssno = 4;
+   	ExpProperties.teamsno = 2;
+   	ExpProperties.mindistance = 60;
    	
-   	ExpParams.pointsCapture = 10;
-   	ExpParams.pointsRetrieve = 5;
-   	ExpParams.pointsScoring = 50;
+   	ExpProperties.pointsCapture = 10;
+   	ExpProperties.pointsRetrieve = 5;
+   	ExpProperties.pointsScoring = 50;
 
 	//Styles of flags
@@ -50,5 +50,5 @@
 function onExpInit()
 {
-	ExpParams_create_call();
+	ExpProperties_create_call();
 
 }
@@ -84,5 +84,5 @@
 }
 
-function ExpParams_create_call(){
+function ExpProperties_create_call(){
 	//Create GenePool and Population for each team
 	GenePools.clear();
@@ -106,5 +106,5 @@
 	
 	var i = 2;
-	for (i = 2; i <= ExpParams.teamsno; i++){
+	for (i = 2; i <= ExpProperties.teamsno; i++){
 		pop=Populations.addGroup("Team"+i);
 		pop.selfmask = 0x50001;
@@ -124,5 +124,5 @@
 }
 
-function ExpParams_fill_call(){
+function ExpProperties_fill_call(){
 	var team = 0;
 	var player = 0;
@@ -141,5 +141,5 @@
 	var ok = 0;
 	
-	for (i = 0; i < ExpParams.teamsno; i++){
+	for (i = 0; i < ExpProperties.teamsno; i++){
 		points.add(0);
 		scored.add(0);
@@ -149,5 +149,5 @@
 	
 	//Clear Populations
-	for (team = 0; team < ExpParams.teamsno; team++){
+	for (team = 0; team < ExpProperties.teamsno; team++){
 		while (Populations[team].size > 0)
 			Populations[team].delete(0);
@@ -162,5 +162,5 @@
 
 		ok = 1;		
-		while (flagsX.size < ExpParams.teamsno && ok == 1){
+		while (flagsX.size < ExpProperties.teamsno && ok == 1){
 			ok = 0;
 			flagTries = 0;
@@ -171,5 +171,5 @@
 				ok = 1;
 				for (i = 0; i < flagsX.size; i++){
-					if (Math.sqrt(Math.pow(flagsX[i] - x, 2)+Math.pow(flagsY[i] - y,2)) < ExpParams.mindistance){
+					if (Math.sqrt(Math.pow(flagsX[i] - x, 2)+Math.pow(flagsY[i] - y,2)) < ExpProperties.mindistance){
 						ok = 0;
 						break;
@@ -185,5 +185,5 @@
 		}
 		
-		if (flagsX.size == ExpParams.teamsno)
+		if (flagsX.size == ExpProperties.teamsno)
 			done = 1;
 		else
@@ -199,9 +199,9 @@
 	
 	//Fill each team's Population with players and a flag and place players close to their flag
-	for (team = 0; team < ExpParams.teamsno; team++){
+	for (team = 0; team < ExpProperties.teamsno; team++){
 		while (Populations[team].size > 0)
 			Populations[team].delete(0);
 		
-		var cr = Populations[team].add(GenePools[ExpParams.teamsno][team]);
+		var cr = Populations[team].add(GenePools[ExpProperties.teamsno][team]);
 		placeFlag(cr);
 		cr.signals.add("Flag");
@@ -214,5 +214,5 @@
 		var crX, crY;
 		
-		for (player = 0; player < ExpParams.memberssno; player++){
+		for (player = 0; player < ExpProperties.memberssno; player++){
 		        var pool=GenePools[team];
 			cr = Populations[team].add(pool[player % pool.size]);
@@ -235,8 +235,8 @@
 }
 
-function ExpParams_default_call(){
+function ExpProperties_default_call(){
 	//Insert default player genotype in team's GenePools
 	var team = 0;
-	for (team = 0; team < ExpParams.teamsno; team++){
+	for (team = 0; team < ExpProperties.teamsno; team++){
 		while (GenePools[team].size > 0)
 			GenePools[team].delete(0);
@@ -272,5 +272,5 @@
 //		line=line+Simulator.time+";";
 //		
-//		for (i = 0; i < ExpParams.teamsno; i++){
+//		for (i = 0; i < ExpProperties.teamsno; i++){
 //			line=line+points[i]+";"+scored[i]+";"+taken[i]+";"+retrieved[i]+";";
 //		}
@@ -299,10 +299,10 @@
 	
 	//Score points for taking a flag
-	creature.user3 += ExpParams.pointsCapture;
+	creature.user3 += ExpProperties.pointsCapture;
 	
 //	Simulator.print("Flag "+(flag.group.index+1)+" taken by team "+(creature.group.index+1));
 	
 	//Update team points and events
-	points[creature.population.index] = points[creature.population.index] + ExpParams.pointsCapture;
+	points[creature.population.index] = points[creature.population.index] + ExpProperties.pointsCapture;
 	taken[creature.population.index] = taken[creature.population.index] + 1;
 
@@ -325,10 +325,10 @@
 
 	//Score points for retrieving a flag
-	creature.user3 += ExpParams.pointsRetrieve;
+	creature.user3 += ExpProperties.pointsRetrieve;
 	
 //	Simulator.print("Flag "+ (flag.group.index+1) +" retrieved");
 	
 	//Update team scores
-	points[creature.population.index] = points[creature.population.index] + ExpParams.pointsRetrieve;
+	points[creature.population.index] = points[creature.population.index] + ExpProperties.pointsRetrieve;
 	retrieved[creature.population.index] = retrieved[creature.population.index] + 1;
 }
@@ -346,10 +346,10 @@
 	
 	//Score points for scoring a flag
-	creature.user3 += ExpParams.pointsScoring;
+	creature.user3 += ExpProperties.pointsScoring;
 	
 //	Simulator.print("Team "+ (creature.group.index + 1) +" scored");
 	
 	//Update team points
-	points[creature.population.index] = points[creature.population.index] + ExpParams.pointsScoring;
+	points[creature.population.index] = points[creature.population.index] + ExpProperties.pointsScoring;
 	scored[creature.population.index] = scored[creature.population.index] + 1;
 }
@@ -419,45 +419,45 @@
 ~
 
-prop:
+property:
 id:teamsno
 name:Number of teams
 type:d 2 5
 
-prop:
+property:
 id:memberssno
 name:Number of members in team
 type:d 1 8
 
-prop:
+property:
 id:mindistance
 name:Minimal distance between flags
 type:d 1 100
 
-prop:
+property:
 id:create
 name:Create teams
 type:p
 
-prop:
+property:
 id:default
 name:Insert default player
 type:p
 
-prop:
+property:
 id:fill
 name:Fill teams
 type:p
 
-prop:
+property:
 id:pointsCapture
 name:Points for flag capture
 type:d 0 100
 
-prop:
+property:
 id:pointsRetrieve
 name:Points for flag retrieve
 type:d 0 100
 
-prop:
+property:
 id:pointsScoring
 name:Points for scoring a flag
Index: /experiments/frams/capture-the-flag/data/scripts/threshold2.neuro
===================================================================
--- /experiments/frams/capture-the-flag/data/scripts/threshold2.neuro	(revision 479)
+++ /experiments/frams/capture-the-flag/data/scripts/threshold2.neuro	(revision 480)
@@ -20,8 +20,8 @@
 function go()
 {
-  if (Neuro.weightedInputSum >= Fields.t)
-    Neuro.state = Fields.hi;
-  else if (Neuro.weightedInputSum <= -Fields.t)
-    Neuro.state = Fields.lo;
+  if (Neuro.weightedInputSum >= NeuroProperties.t)
+    Neuro.state = NeuroProperties.hi;
+  else if (Neuro.weightedInputSum <= -NeuroProperties.t)
+    Neuro.state = NeuroProperties.lo;
   else
     Neuro.state = Neuro.weightedInputSum;
@@ -29,15 +29,15 @@
 ~
 
-prop:
+property:
 id:t
 name:threshold
 type:f
 
-prop:
+property:
 id:lo
 name:low output value
 type:f
 
-prop:
+property:
 id:hi
 name:high output value
Index: /experiments/frams/deathmatch/data/scripts/deathmatch-levels.inc
===================================================================
--- /experiments/frams/deathmatch/data/scripts/deathmatch-levels.inc	(revision 479)
+++ /experiments/frams/deathmatch/data/scripts/deathmatch-levels.inc	(revision 480)
@@ -2,5 +2,5 @@
 // 1. global variable levels
 // 2. function initLevels() that initializes levels structure
-// 3. function nextLevel() that puts into ExpParams.level variable the value of next level's index (or -1 if random) 
+// 3. function nextLevel() that puts into ExpProperties.level variable the value of next level's index (or -1 if random) 
 
 // descriptions of game levels
Index: /experiments/frams/deathmatch/data/scripts/deathmatch-smellPopulation.neuro
===================================================================
--- /experiments/frams/deathmatch/data/scripts/deathmatch-smellPopulation.neuro	(revision 479)
+++ /experiments/frams/deathmatch/data/scripts/deathmatch-smellPopulation.neuro	(revision 480)
@@ -15,6 +15,6 @@
 function go()
 {
-  if (Populations.size>Fields.pop)
-	Neuro.state = Populations[Fields.pop].senseCreaturesProperty(
+  if (Populations.size>NeuroProperties.pop)
+	Neuro.state = Populations[NeuroProperties.pop].senseCreaturesProperty(
 		Neuro.position_x, Neuro.position_y, Neuro.position_z,
 		"energy", Neuro.creature);
@@ -24,5 +24,5 @@
 ~
 
-prop:
+property:
 id:pop
 name:population
Index: /experiments/frams/deathmatch/data/scripts/deathmatch.expdef
===================================================================
--- /experiments/frams/deathmatch/data/scripts/deathmatch.expdef	(revision 479)
+++ /experiments/frams/deathmatch/data/scripts/deathmatch.expdef	(revision 480)
@@ -97,5 +97,5 @@
   //add Teams populations (group above 2)
   var i = 0;
-  teams = ExpParams.teamCount;
+  teams = ExpProperties.teamCount;
   if (teams == 1)
 	teams = GenePools[0].size;
@@ -128,8 +128,8 @@
   for (var i = 0; i < Populations.size - 2; i++)
   {
-	for (var j = 0; j < ExpParams.teamSize; j++)
+	for (var j = 0; j < ExpProperties.teamSize; j++)
 	{
 	  var g; //Genotype object
-	  if (ExpParams.teamCount != 1)
+	  if (ExpProperties.teamCount != 1)
 	    g = GenePools[0].random();
 	  else
@@ -179,8 +179,8 @@
 {
   var levelNumber;
-  if (ExpParams.level == -1)
+  if (ExpProperties.level == -1)
     levelNumber = Math.random(levels.size);
   else
-    levelNumber = ExpParams.level;
+    levelNumber = ExpProperties.level;
 
   var level = levels.get(levelNumber);
@@ -198,12 +198,12 @@
 function tryCreateHPBox()
 {
-  if (Populations[0].size >= ExpParams.hpBoxTotalCount) return;
-  
-  if (Math.rnd01 > ExpParams.hpBoxProbability) return;
+  if (Populations[0].size >= ExpProperties.hpBoxTotalCount) return;
+  
+  if (Math.rnd01 > ExpProperties.hpBoxProbability) return;
   
   var food = Populations[0].add("//0\nm:Vstyle=hpbox\np:");
   food.name = "HP Box";
-  food.idleen = ExpParams.hpBoxIdleEnergy;
-  food.energ0 = ExpParams.hpBoxStartingEnergy;
+  food.idleen = ExpProperties.hpBoxIdleEnergy;
+  food.energ0 = ExpProperties.hpBoxStartingEnergy;
   food.energy = food.energ0;
   food.nnenabled = 0;
@@ -212,12 +212,12 @@
 function tryCreateUpgradeBox()
 {
-  if (Populations[1].size >= ExpParams.upgradeBoxTotalCount) return;
-  
-  if (Math.rnd01 > ExpParams.upgradeBoxProbability) return;
+  if (Populations[1].size >= ExpProperties.upgradeBoxTotalCount) return;
+  
+  if (Math.rnd01 > ExpProperties.upgradeBoxProbability) return;
   
   var weapon = Populations[1].add("//0\nm:Vstyle=weaponbox\np:");
   weapon.name = "Weapon Box";
-  weapon.idleen = ExpParams.upgradeBoxIdleEnergy;
-  weapon.energ0 = ExpParams.upgradeBoxStartingEnergy;
+  weapon.idleen = ExpProperties.upgradeBoxIdleEnergy;
+  weapon.energ0 = ExpProperties.upgradeBoxStartingEnergy;
   weapon.energy = weapon.energ0;
   weapon.nnenabled = 0;
@@ -244,5 +244,5 @@
 	  cr.user2 = [0,0,0,0,0,0]; //kills (0), assists (1), total damage dealt (2), total damage received (3), HP boxes collected (4), Upgrade boxes collected (5)
 	  cr.user3 = []; //who dealt damage to this creature
-	  cr.energ0 = ExpParams.creatureStartingEnergy;
+	  cr.energ0 = ExpProperties.creatureStartingEnergy;
 	  cr.energy = cr.energ0;
       place_inTeamSpot(cr);
@@ -284,9 +284,9 @@
 
   var x, y, z;
-  x = (ExpParams.teamSpawningAreaSize) * Math.rnd01 - cr.size_x / 2 - ExpParams.teamSpawningAreaSize/2;
-  y = (ExpParams.teamSpawningAreaSize) * Math.rnd01 - cr.size_y / 2 - ExpParams.teamSpawningAreaSize/2;
+  x = (ExpProperties.teamSpawningAreaSize) * Math.rnd01 - cr.size_x / 2 - ExpProperties.teamSpawningAreaSize/2;
+  y = (ExpProperties.teamSpawningAreaSize) * Math.rnd01 - cr.size_y / 2 - ExpProperties.teamSpawningAreaSize/2;
   
   //vector of length half the world size minus spawning area size
-  var vect = [0.0 + World.wrldsiz/2 - ExpParams.teamSpawningAreaSize/2 - 1.0, 0.0];
+  var vect = [0.0 + World.wrldsiz/2 - ExpProperties.teamSpawningAreaSize/2 - 1.0, 0.0];
   vect = rotateVector(vect, radius);
   
@@ -366,9 +366,9 @@
 function applySuddenDeathModifier()
 {
-  if (idleSimulationSteps < ExpParams.stagnationInterval) return;
+  if (idleSimulationSteps < ExpProperties.stagnationInterval) return;
 
   for (var i = 2; i < Populations.size; i++)
     for (var cr in Populations[i])
-      cr.energy -= ExpParams.stagnationHealthReduce;
+      cr.energy -= ExpProperties.stagnationHealthReduce;
 }
 
@@ -384,5 +384,5 @@
 	    if (cr.user1[0] > 0) cr.user1[0]=cr.user1[0] - 1;
 	    if (cr.user1[0] < 0) cr.user1[0]=0.0;
-	    if (cr.user1[1] > 0) cr.user1[1]=cr.user1[1] - ExpParams.upgradeBoxDecay;
+	    if (cr.user1[1] > 0) cr.user1[1]=cr.user1[1] - ExpProperties.upgradeBoxDecay;
 	    if (cr.user1[1] < 0) cr.user1[1]=0.0;
 	  }
@@ -432,5 +432,5 @@
 function print(msg)
 {
-  if (ExpParams.debug)
+  if (ExpProperties.debug)
     Simulator.print(msg);
 }
@@ -483,17 +483,17 @@
   var dice2 = 0;
   var changed = 0;
-  for (var i = 0; i < ExpParams.diceCount; i++)
-  {
-    dice1 = dice1 + Math.random(ExpParams.diceSides) + 1;
-	dice2 = dice2 + Math.random(ExpParams.diceSides) + 1;
-  }
-  var energy1 = 0.0 + ExpParams.creatureDamage * dice1;
-  var energy2 = 0.0 + ExpParams.creatureDamage * dice2;
-  energy1 += ExpParams.upgradeMultiplier * c1.user1.get(1);
-  energy2 += ExpParams.upgradeMultiplier * c2.user1.get(1);
+  for (var i = 0; i < ExpProperties.diceCount; i++)
+  {
+    dice1 = dice1 + Math.random(ExpProperties.diceSides) + 1;
+	dice2 = dice2 + Math.random(ExpProperties.diceSides) + 1;
+  }
+  var energy1 = 0.0 + ExpProperties.creatureDamage * dice1;
+  var energy2 = 0.0 + ExpProperties.creatureDamage * dice2;
+  energy1 += ExpProperties.upgradeMultiplier * c1.user1.get(1);
+  energy2 += ExpProperties.upgradeMultiplier * c2.user1.get(1);
   if (c1.population == c2.population)
   {
-    energy1 = ExpParams.friendlyFireDamageMultiplier * energy1;
-	energy2 = ExpParams.friendlyFireDamageMultiplier * energy2;
+    energy1 = ExpProperties.friendlyFireDamageMultiplier * energy1;
+	energy2 = ExpProperties.friendlyFireDamageMultiplier * energy2;
   }
   
@@ -511,6 +511,6 @@
     c1.energy = c1.energy - energy2;
 	if (c1.energy < 0) c1.energy = 0;
-    print(c2.name + " [" + c2.population.name + "] rolled " + dice2 + " and dealt " + energy2 + " [+" + (ExpParams.upgradeMultiplier * c2.user1[1]) +" bonus] damage to " + c1.name + " [" + c1.population.name + "]");
-	c2.user1.set(0, ExpParams.attackCooldown);
+    print(c2.name + " [" + c2.population.name + "] rolled " + dice2 + " and dealt " + energy2 + " [+" + (ExpProperties.upgradeMultiplier * c2.user1[1]) +" bonus] damage to " + c1.name + " [" + c1.population.name + "]");
+	c2.user1.set(0, ExpProperties.attackCooldown);
 	c2.user2.set(2, c2.user2[2] + energy1);
 	c1.user2.set(3, c1.user2[3] + energy1);
@@ -543,6 +543,6 @@
     c2.energy = c2.energy - energy1;
 	if (c2.energy < 0) c2.energy = 0;
-    print(c1.name + " [" + c1.population.name + "] rolled " + dice1 + " and dealt " + energy1 + " [+" + (ExpParams.upgradeMultiplier * c1.user1[1]) +" bonus] damage to " + c2.name + " [" + c2.population.name + "]");
-    c1.user1[0] = ExpParams.attackCooldown;
+    print(c1.name + " [" + c1.population.name + "] rolled " + dice1 + " and dealt " + energy1 + " [+" + (ExpProperties.upgradeMultiplier * c1.user1[1]) +" bonus] damage to " + c2.name + " [" + c2.population.name + "]");
+    c1.user1[0] = ExpProperties.attackCooldown;
 	c1.user2[2] = c1.user2[2] + energy1;
 	c2.user2[3] = c2.user2[3] + energy1;
@@ -588,5 +588,5 @@
 function onFoodCollision()
 {
-  if (ExpParams.pickupNotStagnation == 1) idleSimulationSteps = 0;
+  if (ExpProperties.pickupNotStagnation == 1) idleSimulationSteps = 0;
 
   //collect HP Box (by eating it :D)
@@ -605,5 +605,5 @@
 function onUpgradesCollision()
 {
-  if (ExpParams.pickupNotStagnation == 1) idleSimulationSteps = 0;
+  if (ExpProperties.pickupNotStagnation == 1) idleSimulationSteps = 0;
 
   //collect Upgrade Box (by eating it :D)
@@ -643,10 +643,10 @@
 
 //reinit populations on change
-function ExpParams_teamCount_set()
+function ExpProperties_teamCount_set()
 {
   initPopulations();
 }
 
-function ExpParams_level_set()
+function ExpProperties_level_set()
 {
   initLevel();
@@ -657,5 +657,5 @@
 # Team
 
-prop:
+property:
 id:teamCount
 name:Number of teams in Deathmatch
@@ -664,5 +664,5 @@
 help:If set to 1, the number of teams will be equal to the number of genotypes in gene pool.
 
-prop:
+property:
 id:teamSize
 name:Number of creatures per team
@@ -670,5 +670,5 @@
 group:Team
 
-prop:
+property:
 id:teamSpawningAreaSize
 name:Spawning area size for team
@@ -676,5 +676,5 @@
 group:Team
 
-prop:
+property:
 id:creatureStartingEnergy
 name:Starting energy of creature
@@ -686,5 +686,5 @@
 # Attack parameters
 
-prop:
+property:
 id:diceSides
 name:Number of sides of dices
@@ -692,5 +692,5 @@
 group:Attack rules
 
-prop:
+property:
 id:diceCount
 name:Number of dices to roll per attack
@@ -698,5 +698,5 @@
 group:Attack rules
 
-prop:
+property:
 id:creatureDamage
 name:Basic damage multiplied by result of dice roll
@@ -704,5 +704,5 @@
 group:Attack rules
 
-prop:
+property:
 id:friendlyFireDamageMultiplier
 name:Multiplier of energy taken when Creatures of the same team collide
@@ -711,5 +711,5 @@
 help:Set to 0 for no friendly fire, set to 1 if full damage should be dealt when interacting with team member
 
-prop:
+property:
 id:attackCooldown
 name:Number of simulation steps between two consecutive attacks of a creature
@@ -721,5 +721,5 @@
 # Collectibles - HP Boxes & Upgrades
 
-prop:
+property:
 id:pickupNotStagnation
 name:Collectible pick-up resets stagnation counter?
@@ -727,5 +727,5 @@
 help:If set to true picking up an item will restart counting towards stagnation, effects in longer battles.
 
-prop:
+property:
 id:hpBoxStartingEnergy
 name:Starting energy of HP Box
@@ -734,5 +734,5 @@
 help:Base starting energy level for HP Box
 
-prop:
+property:
 id:hpBoxIdleEnergy
 name:Amount of energy lost by HP Box
@@ -741,5 +741,5 @@
 help:How much energy HP Box looses each step (0 - it will not disappear)
 
-prop:
+property:
 id:hpBoxProbability
 name:Probablity that new HP Box will spawn
@@ -748,5 +748,5 @@
 help:Probability of HP Box appearing each step of simulation
 
-prop:
+property:
 id:hpBoxTotalCount
 name:Maximum number of HP Boxes on the field
@@ -755,5 +755,5 @@
 help:The total number of HP Boxes on the field will never exceed this number
 
-prop:
+property:
 id:upgradeBoxStartingEnergy
 name:Starting energy of Upgrade Box
@@ -762,5 +762,5 @@
 help:Base starting energy level for Upgrade Box
 
-prop:
+property:
 id:upgradeBoxIdleEnergy
 name:Amount of energy lost by Upgrade Box
@@ -769,5 +769,5 @@
 help:How much energy Upgrade Box looses each step (0 - it will not disappear)
 
-prop:
+property:
 id:upgradeBoxProbability
 name:Probablity that new Upgrade Box will spawn
@@ -776,5 +776,5 @@
 help:Probability of Upgrade Box appearing each step of simulation
 
-prop:
+property:
 id:upgradeBoxTotalCount
 name:Maximum number of Upgrade Boxes on the field
@@ -783,5 +783,5 @@
 help:The total number of Upgrade Boxes on the field will never exceed this number
 
-prop:
+property:
 id:upgradeBoxDecay
 name:How fast upgrade boost fades from creature
@@ -790,5 +790,5 @@
 help:Each step creature damage bonus will be decreased by given amount until it reaches 0
 
-prop:
+property:
 id:upgradeMultiplier
 name:Multiplier of bonus damage
@@ -800,5 +800,5 @@
 # Other
 
-prop:
+property:
 id:level
 name:Level
@@ -806,5 +806,5 @@
 help:Number of a level to battle (-1 is random)
 
-prop:
+property:
 id:stagnationInterval
 name:Number of idle simulation steps before Sudden Death
@@ -812,5 +812,5 @@
 help:If no combat occurs during given number of steps, the Sudden Death mode is turned on (0 = Sudden Death all the time)
 
-prop:
+property:
 id:stagnationHealthReduce
 name:Sudden Death health reduce
@@ -818,5 +818,5 @@
 help:If Suddent Death is turned on, creatures will lose given amount of HP each simulation step
 
-prop:
+property:
 id:debug
 name:Show additional debug messages
Index: /experiments/frams/evolve-speed-vs-gravity/data/scripts/evolve-speed-vs-gravity.script
===================================================================
--- /experiments/frams/evolve-speed-vs-gravity/data/scripts/evolve-speed-vs-gravity.script	(revision 479)
+++ /experiments/frams/evolve-speed-vs-gravity/data/scripts/evolve-speed-vs-gravity.script	(revision 480)
@@ -8,5 +8,5 @@
 	World.wrldg=gravity;
 	Populations[0].perfperiod=100000; //fitness: velocity serves as distance (because sampling period is longer than lifespan)
-	ExpParams.initialgen="XX[|,1:1][N,1:1,2:1][T][G]";
+	ExpProperties.initialgen="XX[|,1:1][N,1:1,2:1][T][G]";
 	
 	//custom fitness function: velocity minus small penalty for complexity (high number of parts, joints, neurons, connections)
Index: /experiments/frams/logic/data/scripts/logic_abduction.expdef
===================================================================
--- /experiments/frams/logic/data/scripts/logic_abduction.expdef	(revision 479)
+++ /experiments/frams/logic/data/scripts/logic_abduction.expdef	(revision 480)
@@ -43,5 +43,5 @@
 {
 	//Initialization of the experiment parameters loaded from file
-	g_params = String.split(ExpParams.params, ";");
+	g_params = String.split(ExpProperties.params, ";");
 	if(g_params.size == 3)
 	{
@@ -252,5 +252,5 @@
 ~
 
-prop:
+property:
 id:params
 name:Logical experiment parameters
Index: /experiments/frams/multi-threading/data/scripts/test-mt.script
===================================================================
--- /experiments/frams/multi-threading/data/scripts/test-mt.script	(revision 479)
+++ /experiments/frams/multi-threading/data/scripts/test-mt.script	(revision 480)
@@ -5,12 +5,12 @@
 function main_args(complexify_geno,timeinterval,intervals)
 {
-	// ExpParams.mix_period (percentage of the gene pool capacity) is kept at the default value (1000%)
+	// ExpProperties.mix_period (percentage of the gene pool capacity) is kept at the default value (1000%)
 
 	Math.randomize();
 	//Simulator.expdef="standard-mt"; //set multithreaded experiment; this is done by the shell script
 	
-	ExpParams.initialgen="XX[|,1:1][N,1:1,2:1][T][G]";
+	ExpProperties.initialgen="XX[|,1:1][N,1:1,2:1][T][G]";
 	for(var i=0;i<complexify_geno;i++) //make a big genotype by doubling the simple one above. Note: exponential!
-		ExpParams.initialgen=ExpParams.initialgen+ExpParams.initialgen;
+		ExpProperties.initialgen=ExpProperties.initialgen+ExpProperties.initialgen;
 	
 	Simulator.init();
@@ -26,5 +26,5 @@
 	        if (iter==(intervals-1))
 		    Simulator.stop();
-		Simulator.print("iter=%d, simsteps=%d, evals=%d, migrations=%d, gen_count=%d, avg_numparts=%g, fit_avg=%g, fit_max=%g, time=%f, migration_time=%f, T=%d, C=%d" % iter % Simulator.stepNumber % ExpState.totaltests % ExpState.migrations % stats.gen_count % stats.st_avg_numparts % stats.st_avg_fit % stats.st_max_fit % (Math.time-t0) % ExpState.migration_time % ExpParams.threads % ExpParams.capacity);
+		Simulator.print("iter=%d, simsteps=%d, evals=%d, migrations=%d, gen_count=%d, avg_numparts=%g, fit_avg=%g, fit_max=%g, time=%f, migration_time=%f, T=%d, C=%d" % iter % Simulator.stepNumber % ExpState.totaltests % ExpState.migrations % stats.gen_count % stats.st_avg_numparts % stats.st_avg_fit % stats.st_max_fit % (Math.time-t0) % ExpState.migration_time % ExpProperties.threads % ExpProperties.capacity);
 		Simulator.print(GenePools[0].best().genotype);
 	}